% Test grasps with randomly generated contacts.   Start with one contact
% and continue adding more contacts.  Always keep the past contacts.  If
% the metric is monotonic, then it will never reduce as the number of
% contacts increases.

% Unilateral contacts only
Gn = [];
figh1 = figure; 
hold on;
grid;
figh2 = figure; 
hold on;
grid;
for i = 1:50
    % Generate random contact normals and contact points
    n = (rand(3,1)-0.5);
    nhat = n / norm(n);
    r = 10*(rand(3,1)-0.5);
    Gn = [Gn [nhat; cross(r, nhat)]];
    [flag, d] = formClosure(Gn);
    figure(figh1);
    plot(i,d,'b+');
    if i > 5
        [flag, d2] = ferrariCanny(Gn);
        figure(figh2);
        plot(i,d2,'ro');
    end
end

% Unilateral and bilateral contacts
figh3 = figure; 
hold on;
grid;
figh4 = figure; 
hold on;
grid;
Gn = [];
B = [];
nb = 4;  % number of bilateral constraints
for i = 1:50
    % Generate random contact normals and contact points
    n = (rand(3,1)-0.5);
    nhat = n / norm(n);
    r = 10*(rand(3,1)-0.5);
    Gn = [Gn [nhat; cross(r, nhat)]];
    if i <= nb
        % Generate random contact normals and positions for bilateral
        % contacs
        x = (rand(3,1)-0.5);
        xhat = x / norm(x);
        r = 10*(rand(3,1)-0.5);
        B = [B [xhat; cross(r, xhat)]];
    end
    [flag, d] = formClosure(Gn, B);
    figure(figh3);
    plot(i,d,'b+');
    if i > 2
        [flag, d2] = ferrariCanny(Gn, B);
        figure(figh4);
        plot(i,d2,'ro');
    end
end